#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QSqlDatabase>
#include <QSqlError>
#include <QSqlQuery>
#include <QSqlRecord>
#include <iostream>
#include <QStringList>
#include <QString>
#include <QVariant>

#include <QDataWidgetMapper>
#include <QtSql>

#include <QStandardItem>
#include <QStringList>
#include <QStringListModel>

QSqlQueryModel *qryModel;          // ģ
QItemSelectionModel *theSelection; // ѡģ
QDataWidgetMapper *dataMapper;     // ݽӳ

// 
void InitMultipleSQL()
{
    // ----------------------------------------------
    // ʼṹ
    // ----------------------------------------------
    QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName("./database.db");
     if (!db.open())
     {
            std::cout << db.lastError().text().toStdString()<< std::endl;
            return;
     }

    // ִSQL
    db.exec("DROP TABLE Student");
    db.exec("CREATE TABLE Student ("
                    "id INTEGER PRIMARY KEY AUTOINCREMENT, "
                    "name VARCHAR(40) NOT NULL, "
                    "age INTEGER NOT NULL)"
         );

    // 
    QStringList name_list; name_list << "lyshark" << "admin" << "guest";
    QStringList age_list; age_list << "25" << "34" << "45";

    // 󶨲
    QSqlQuery query;
    query.prepare("INSERT INTO Student(name,age) ""VALUES (:name, :age)");

    if(name_list.size() == age_list.size())
    {
        for(int x=0;x< name_list.size();x++)
        {
            query.bindValue(":name",name_list[x]);
            query.bindValue(":age",age_list[x]);
            query.exec();
        }
    }

    // ----------------------------------------------
    // ڶű
    // ----------------------------------------------
    // һűͨ
    db.exec("DROP TABLE StudentAddressList");
    db.exec("CREATE TABLE StudentAddressList("
            "id INTEGER PRIMARY KEY AUTOINCREMENT, "
            "name VARCHAR(40) NOT NULL, "
            "address VARCHAR(128) NOT NULL"
            ")");

    // 
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('lyshark','192.168.1.1')");
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('lyshark','192.168.1.2')");
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('lyshark','192.168.1.3')");
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('admin','192.168.10.10')");
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('admin','192.168.10.11')");
    db.exec("INSERT INTO StudentAddressList(name,address) VALUES ('guest','192.168.100.100')");
}

MainWindow::MainWindow(QWidget *parent) :QMainWindow(parent),ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    // ʼṹ
    InitMultipleSQL();

    // ݿ
    QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName("./database.db");
    if (!db.open())
    {
        std::cout << db.lastError().text().toStdString()<< std::endl;
        return;
    }

    // ѯݱм¼
    qryModel=new QSqlQueryModel(this);
    qryModel->setQuery("SELECT * FROM Student ORDER BY id");
    if (qryModel->lastError().isValid())
    {
        return;
    }

    // TableViewͷ
    qryModel->setHeaderData(0,Qt::Horizontal,"ID");
    qryModel->setHeaderData(1,Qt::Horizontal,"Name");
    qryModel->setHeaderData(2,Qt::Horizontal,"Age");

    // ݰ󶨵ģ
    theSelection=new QItemSelectionModel(qryModel);
    ui->tableView->setModel(qryModel);
    ui->tableView->setSelectionModel(theSelection);
    ui->tableView->setSelectionBehavior(QAbstractItemView::SelectRows);

    // ӳ
    dataMapper= new QDataWidgetMapper();
    dataMapper->setSubmitPolicy(QDataWidgetMapper::AutoSubmit);
    dataMapper->setModel(qryModel);
    dataMapper->addMapping(ui->lineEdit_id,0);
    dataMapper->addMapping(ui->lineEdit_name,1);
    dataMapper->addMapping(ui->lineEdit_age,2);
    dataMapper->toFirst();

    // ź,ѡʱ,ڵײ༭
    connect(theSelection,SIGNAL(currentRowChanged(QModelIndex,QModelIndex)),
            this,SLOT(on_currentRowChanged(QModelIndex,QModelIndex)));
}

// Ĵۺ
void MainWindow::on_currentRowChanged(const QModelIndex &current, const QModelIndex &previous)
{
    Q_UNUSED(previous);
    if (!current.isValid())
    {
        return;
    }

    dataMapper->setCurrentModelIndex(current);

    // ȡ¼ͷβ
    bool first=(current.row()==0);                    // Ƿ׼¼
    bool last=(current.row()==qryModel->rowCount()-1);// Ƿβ¼
    std::cout << "IsFirst: " << first << "IsLast: " << last << std::endl;


    // ȡnameֶ
    int curRecNo=theSelection->currentIndex().row();  // ȡǰк
    QSqlRecord curRec=qryModel->record(curRecNo);     // ȡǰ¼
    QString uname = curRec.value("name").toString();
    std::cout << "Student Name = " << uname.toStdString() << std::endl;

    // StudentAddressList
    // ˳û
    QSqlQuery query;
    query.prepare("select * from StudentAddressList where name = :x");
    query.bindValue(":x",uname);
    query.exec();

    // ѭȡû,addressֶȡQStringList
    QSqlRecord rec = query.record();
    QStringList the_data;

    while(query.next())
    {
        int index = rec.indexOf("address");
        QString data = query.value(index).toString();

        std::cout << "User Address = " << data.toStdString() << std::endl;
        the_data.append(data);
    }

    // ListViewݱ
    QStringListModel *model;
    model = new QStringListModel(the_data);
    ui->listView->setModel(model);
    ui->listView->setEditTriggers(QAbstractItemView::NoEditTriggers);
}

MainWindow::~MainWindow()
{
    delete ui;
}

//ˢtableViewĵǰѡ
void MainWindow::refreshTableView()
{
    int index=dataMapper->currentIndex();
    QModelIndex curIndex=qryModel->index(index,0);      // λ00
    theSelection->clearSelection();                     // ѡ
    theSelection->setCurrentIndex(curIndex,QItemSelectionModel::Select);//øղΪǰѡ
}

// һ¼
void MainWindow::on_pushButton_clicked()
{
    dataMapper->toFirst();
    refreshTableView();
}
// һ¼
void MainWindow::on_pushButton_2_clicked()
{
    dataMapper->toLast();
    refreshTableView();
}

// ǰһ¼
void MainWindow::on_pushButton_3_clicked()
{
    dataMapper->toPrevious();
    refreshTableView();
}

// һ¼
void MainWindow::on_pushButton_4_clicked()
{
    dataMapper->toNext();
    refreshTableView();
}
